
/*
	TEDDY - General graphics application library
	Copyright (C) 1999-2002  Timo Suoranta
	tksuoran@cc.helsinki.fi

	This library is free software; you can redistribute it and/or
	modify it under the terms of the GNU Lesser General Public
	License as published by the Free Software Foundation; either
	version 2.1 of the License, or (at your option) any later version.

	This library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
	
	$Id:  $
*/


#ifndef TEDDY__SCENES__ELLIPSOID__H
#define TEDDY__SCENES__ELLIPSOID__H


#include "Teddy/Maths/Vector.h"
using namespace Teddy::Maths;


namespace Teddy  {
namespace Scenes {


class Ellipsoid {
public:
	Ellipsoid( Vector location, Vector forward, double radius, double front, double rear );

public:
	Vector  location;
    Vector  forward;
	double  radius;
	double  front;
    double  rear;
    double  clip_radius; // max(front, rear)*forward.length + radius
};


};  //  namespace Scenes
};  //  namespace Teddy


#endif  //  TEDDY__SCENES__ELLIPSOID__H

